Subject: bug#41878: closed (Re: bug#41878: 'guix substitute' and 'guix pull' fail gracelessly on flaky networks)

From: [email-masked] (GNU bug Tracking System)
Date: Tue, 18 Mar 2025 01:37:02 +0000

Your bug report

#41878: 'guix substitute' and 'guix pull' fail gracelessly on flaky networks

which was filed against the guix package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
41878: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=41878
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#41878: 'guix substitute' and 'guix pull' fail gracelessly on flaky networks
From: Maxim Cournoyer <[email-masked]>
To: Ludovic Courtès <[email-masked]>
Cc: [email-masked], Quinten Gruenthal <[email-masked]>
Date: Tue, 18 Mar 2025 10:35:37 +0900
List-Id: <debbugs-submit.debbugs.gnu.org>

Hi Ludovic,

Ludovic Courtès <[email-masked]> writes:

> Hi,
>
> Quinten Gruenthal <[email-masked]> skribis:
>
>> Yes and yes. I didn't state explicitly that it was a problem with my
>> network only because I didn't want to appear overconfident in my amateur
>> diagnosis and I definitely prefer the second error message to the one that
>> dumps a trace and prompts the filing of a bug. This:
>>
>> substitute: guix substitute: error: TLS error in procedure 'handshake':
>> Error in the pull function.
>
> I see.  I’ll take a look and see how we can improve on this.

I believe that's been fixed in commit
fa70c141552c76cf4dc9666f577bf6b471fa0d50 ("substitute: Reopen connection
upon “Error in the push function” from GnuTLS.").

Closing.

-- 
Thanks,
Maxim

Subject: Handshake Error
From: Quinten Gruenthal <[email-masked]>
To: [email-masked]
Date: Mon, 15 Jun 2020 09:30:34 -0700
List-Id: <debbugs-submit.debbugs.gnu.org>

I received the following error when performing a guix pull:

|substitute: guix substitute: error: TLS error in procedure 'handshake':
Error in the pull function.
killing process 8828
Backtrace:
          11 (primitive-load
"/gnu/store/pl48b057h6yg8w6f7hafiilcc44d0fn6-compute-guix-derivation")
In ice-9/eval.scm:
    155:9 10 (_ _)
    159:9  9 (_ #(#(#(#(#(#(#(#(#(#(#(#(#(#<directory (guile-user)
7fc5ff085f?> ?) ?) ?) ?) ?) ?) ?) ?) ?) ?) ?) ?) ?))
In ./guix/store.scm:
  2025:24  8 (run-with-store #<store-connection 256.99 7fc5fd407640> _
#:guile-for-build _ #:system _ #:target _)
   1859:8  7 (_ _)
In ./guix/gexp.scm:
   243:18  6 (_ _)
   1061:2  5 (_ _)
    921:2  4 (_ _)
    782:4  3 (_ _)
In ./guix/store.scm:
  1907:12  2 (_ #<store-connection 256.99 7fc5fd407640>)
   1356:5  1 (map/accumulate-builds #<store-connection 256.99 7fc5fd407640>
_ _)
  1367:15  0 (_ #<store-connection 256.99 7fc5fd407640> _ _)

./guix/store.scm:1367:15: ERROR:
  1. &store-protocol-error:
      message: "`/gnu/store/5r3sb6bj6pppn4h35a35956mv5qrd011-guix-command
substitute' died unexpectedly"
      status: 1
guix pull: error: You found a bug: the program
'/gnu/store/pl48b057h6yg8w6f7hafiilcc44d0fn6-compute-guix-derivation'
failed to compute the derivation for Guix (version:
"cf48f0fc4c40a2ec0b38a445e1e13f37722a0ade"; system: "x86_64-linux";
host version: "ecf92194a55188a9c217d76617378749db063453"; pull-version: 1).
Please report it by email to <[email-masked]>.

I've seen this kind of error before in other software and I believe it
occurs when a handshake can't be performed in time and the connection is
dropped; I was able to successfully pull a few minutes later under better
conditions. That being said I bring this up because a problem in my network
(I think) is being treated like an error in your program.